/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.46 Revision 1.77
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.46 2007/08/14 12:50:16 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.77 2011/12/31 01:01:56 hd_brummy Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
9# vdr-plugin.eclass 9# vdr-plugin.eclass
10# 10#
11# eclass to create ebuilds for vdr plugins 11# eclass to create ebuilds for vdr plugins
12# 12#
13 13
14# Example ebuild (vdr-femon): 14# Example ebuild (basic version without patching):
15# 15#
16# EAPI="2"
16# inherit vdr-plugin 17# inherit vdr-plugin
17# IUSE="" 18# IUSE=""
18# SLOT="0" 19# SLOT="0"
19# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)" 20# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)"
20# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/" 21# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/"
21# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz" 22# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz"
22# LICENSE="GPL-2" 23# LICENSE="GPL-2"
23# KEYWORDS="~x86" 24# KEYWORDS="~x86"
24# DEPEND=">=media-video/vdr-1.3.27" 25# DEPEND=">=media-video/vdr-1.6.0"
25# 26#
26# 27#
28
29# For patching you should modify src_prepare phase:
30#
31# src_prepare() {
32# epatch "${FILESDIR}"/${P}-xxx.patch
33# vdr-plugin_src_prepare
34# }
27 35
28# Installation of a config file for the plugin 36# Installation of a config file for the plugin
29# 37#
30# If ${VDR_CONFD_FILE} is set install this file 38# If ${VDR_CONFD_FILE} is set install this file
31# else install ${FILESDIR}/confd if it exists. 39# else install ${FILESDIR}/confd if it exists.
57# 65#
58# all patches which ending on diff or patch in this DIR will automatically applied 66# all patches which ending on diff or patch in this DIR will automatically applied
59# 67#
60 68
61inherit base multilib eutils flag-o-matic 69inherit base multilib eutils flag-o-matic
70
71if ! has "${EAPI:-0}" 0 1 2 3; then
72 die "API of vdr-plugin.eclass in EAPI=\"${EAPI}\" not established"
73fi
62 74
63IUSE="" 75IUSE=""
64 76
65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 77# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66VDRPLUGIN="${PN/#vdrplugin-/}" 78VDRPLUGIN="${PN/#vdrplugin-/}"
71 83
72# works in most cases 84# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 85S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 86
75# depend on headers for DVB-driver 87# depend on headers for DVB-driver
76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1" 88COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
89
90DEPEND="${COMMON_DEPEND}
77DEPEND="media-tv/linuxtv-dvb-headers" 91 media-tv/linuxtv-dvb-headers"
92RDEPEND="${COMMON_DEPEND}
93 >=app-admin/eselect-vdr-0.0.2"
78 94
79 95# this is a hack for ebuilds like vdr-xineliboutput that want to
80# this code is from linux-mod.eclass 96# conditionally install a vdr-plugin
81update_vdrplugindb() { 97if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 98 # make DEPEND conditional
83 99 IUSE="${IUSE} vdr"
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then 100 DEPEND="vdr? ( ${DEPEND} )"
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR} 101 RDEPEND="vdr? ( ${RDEPEND} )"
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi 102fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92}
93
94remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi
101}
102 103
103# New method of storing plugindb 104# New method of storing plugindb
104# Called from src_install 105# Called from src_install
105# file maintained by normal portage-methods 106# file maintained by normal portage-methods
106create_plugindb_file() { 107create_plugindb_file() {
107 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 108 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
108 local DB_FILE=${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 109 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
109 insinto ${NEW_VDRPLUGINDB_DIR} 110 insinto "${NEW_VDRPLUGINDB_DIR}"
111
112# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
110 cat <<-EOT > ${D}/${DB_FILE} 113# cat <<-EOT > "${D}/${DB_FILE}"
111 VDRPLUGIN_DB=1 114# VDRPLUGIN_DB=1
112 CREATOR=ECLASS 115# CREATOR=ECLASS
113 EBUILD=${CATEGORY}/${PN} 116# EBUILD=${CATEGORY}/${PN}
114 EBUILD_V=${PVR} 117# EBUILD_V=${PVR}
115 EOT 118# EOT
119 {
120 echo "VDRPLUGIN_DB=1"
121 echo "CREATOR=ECLASS"
122 echo "EBUILD=${CATEGORY}/${PN}"
123 echo "EBUILD_V=${PVR}"
124 echo "PLUGINS=\"$@\""
125 } > "${D}/${DB_FILE}"
116} 126}
117 127
118# Delete files created outside of vdr-plugin.eclass 128# Delete files created outside of vdr-plugin.eclass
119# vdrplugin-rebuild.ebuild converted plugindb and files are 129# vdrplugin-rebuild.ebuild converted plugindb and files are
120# not deleted by portage itself - should only be needed as 130# not deleted by portage itself - should only be needed as
121# long as not every system has switched over to 131# long as not every system has switched over to
122# vdrplugin-rebuild-0.2 132# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
123delete_orphan_plugindb_file() { 133delete_orphan_plugindb_file() {
124 #elog Testing for orphaned plugindb file 134 #elog Testing for orphaned plugindb file
125 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 135 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
126 local DB_FILE=${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 136 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
127 137
128 # file exists 138 # file exists
129 [[ -f ${DB_FILE} ]] || return 139 [[ -f ${DB_FILE} ]] || return
130 140
131 # will portage handle the file itself 141 # will portage handle the file itself
132 if grep -q CREATOR=ECLASS ${DB_FILE}; then 142 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
133 #elog file owned by eclass - don't touch it 143 #elog file owned by eclass - don't touch it
134 return 144 return
135 fi 145 fi
136 146
137 elog "Removing orphaned plugindb-file." 147 elog "Removing orphaned plugindb-file."
138 elog "\t#rm ${DB_FILE}" 148 elog "\t#rm ${DB_FILE}"
139 rm ${DB_FILE} 149 rm "${DB_FILE}"
140} 150}
141 151
142 152
143create_header_checksum_file() 153create_header_checksum_file()
144{ 154{
145 # Danger: Not using $ROOT here, as compile will also not use it !!! 155 # Danger: Not using $ROOT here, as compile will also not use it !!!
146 # If vdr in $ROOT and / differ, plugins will not run anyway 156 # If vdr in $ROOT and / differ, plugins will not run anyway
147 157
148 insinto ${VDR_CHECKSUM_DIR} 158 local CHKSUM="header-md5-vdr"
159
149 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 160 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
150 newins ${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN} 161 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
162 elif type -p md5sum >/dev/null 2>&1; then
163 (
164 cd "${VDR_INCLUDE_DIR}"
165 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
166 ) > "${CHKSUM}"
151 else 167 else
152 if type -p md5sum >/dev/null 2>&1; then 168 die "Could not create md5 checksum of headers"
153 cd ${S} 169 fi
154 ( 170
155 cd ${VDR_INCLUDE_DIR} 171 insinto "${VDR_CHECKSUM_DIR}"
156 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 172 local p_name
157 ) > header-md5-${PN} 173 for p_name; do
158 doins header-md5-${PN} 174 newins "${CHKSUM}" "header-md5-${p_name}"
175 done
176}
177
178fix_vdr_libsi_include()
179{
180 #einfo "Fixing include of libsi-headers"
181 local f
182 for f; do
183 sed -i "${f}" \
184 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
185 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
186 done
187}
188
189vdr_patchmakefile() {
190 einfo "Patching Makefile"
191 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
192 cp Makefile "${WORKDIR}"/Makefile.before
193
194 # plugin makefiles use VDRDIR in strange ways
195 # assumptions:
196 # 1. $(VDRDIR) contains Make.config
197 # 2. $(VDRDIR) contains config.h
198 # 3. $(VDRDIR)/include/vdr contains the headers
199 # 4. $(VDRDIR) contains main vdr Makefile
200 # 5. $(VDRDIR)/locale exists
201 # 6. $(VDRDIR) allows to access vdr source files
202 #
203 # We only have one directory (for now /usr/include/vdr),
204 # that contains vdr-headers and Make.config.
205 # To satisfy 1-3 we do this:
206 # Set VDRDIR=/usr/include/vdr
207 # Set VDRINCDIR=/usr/include
208 # Change $(VDRDIR)/include to $(VDRINCDIR)
209
210 sed -i Makefile \
211 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
212 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
213 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
214 \
215 -e 's:-I$(DVBDIR)/include::' \
216 -e 's:-I$(DVBDIR)::'
217
218 # maybe needed for multiproto:
219 #sed -i Makefile \
220 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
221 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
222
223 if ! grep -q APIVERSION Makefile; then
224 ebegin " Converting to APIVERSION"
225 sed -i Makefile \
226 -e 's:^APIVERSION = :APIVERSION ?= :' \
227 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
228 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
229 eend $?
230 fi
231
232 # Correcting Compile-Flags
233 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
234 sed -i Makefile \
235 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
236 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
237
238 # Disabling file stripping, useful for debugging
239 sed -i Makefile \
240 -e '/@.*strip/d' \
241 -e '/strip \$(LIBDIR)\/\$@/d' \
242 -e 's/STRIP.*=.*$/STRIP = true/'
243
244 # Use a file instead of a variable as single-stepping via ebuild
245 # destroys environment.
246 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
247}
248
249vdr_add_local_patch() {
250 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
251 echo
252 einfo "Applying local patches"
253 for LOCALPATCH in "${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}"/*.{diff,patch}; do
254 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
255 done
256 fi
257}
258
259vdr_has_gettext() {
260 has_version ">=media-video/vdr-1.5.7"
261}
262
263plugin_has_gettext() {
264 [[ -d po ]]
265}
266
267vdr_i18n_convert_to_gettext() {
268 if has_version ">=media-video/vdr-1.7.22"; then
269 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext"
270 else
271 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
272 fi
273
274 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
275 ewarn "Conversion to gettext disabled in ebuild"
276 return 1
277 fi
278
279 if [[ ! -x ${i18n_tool} ]]; then
280 eerror "Missing ${i18n_tool}"
281 eerror "Please re-emerge vdr"
282 die "Missing ${i18n_tool}"
283 fi
284
285 ebegin "Auto converting translations to gettext"
286 # call i18n-to-gettext tool
287 # take all texts missing tr call into special file
288 "${i18n_tool}" 2>/dev/null \
289 |sed -e '/^"/!d' \
290 -e '/^""$/d' \
291 -e 's/\(.*\)/trNOOP(\1)/' \
292 > dummy-translations-trNOOP.c
293
294 # if there were untranslated texts just run it again
295 # now the missing calls are listed in
296 # dummy-translations-trNOOP.c
297 if [[ -s dummy-translations-trNOOP.c ]]; then
298 "${i18n_tool}" &>/dev/null
299 fi
300
301 # now use the modified Makefile
302 if [[ -f Makefile.new ]]; then
303 mv Makefile.new Makefile
304 eend 0 ""
305 else
306 eend 1 "Conversion to gettext failed. Plugin needs fixing."
307 return 1
308 fi
309}
310
311vdr_i18n_disable_gettext() {
312 #einfo "Disabling gettext support in plugin"
313
314 # Remove i18n Target if using older vdr
315 sed -i Makefile \
316 -e '/^all:/s/ i18n//'
317}
318
319vdr_i18n() {
320 if vdr_has_gettext; then
321 #einfo "VDR has gettext support"
322 if plugin_has_gettext; then
323 #einfo "Plugin has gettext support, fine"
324 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
325 ewarn "Please remove unneeded NO_GETTEXT_HACK from ebuild."
326 fi
327 else
328 vdr_i18n_convert_to_gettext
329 if [[ $? != 0 ]]; then
330 eerror ""
331 eerror "Plugin will have only english OSD texts"
332 eerror "it needs manual fixing."
333 fi
159 fi 334 fi
335 else
336 #einfo "VDR has no gettext support"
337 if plugin_has_gettext; then
338 vdr_i18n_disable_gettext
160 fi 339 fi
340 fi
161} 341}
342
343vdr-plugin_copy_source_tree() {
344 pushd . >/dev/null
345 cp -r "${S}" "${T}"/source-tree
346 cd "${T}"/source-tree
347 cp "${WORKDIR}"/Makefile.before Makefile
348 # TODO: Fix this, maybe no longer needed
349 sed -i Makefile \
350 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
351 -e 's:^CXXFLAGS:#CXXFLAGS:' \
352 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
353 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
354 popd >/dev/null
355}
356
357vdr-plugin_install_source_tree() {
358 einfo "Installing sources"
359 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
360 insinto "${destdir}-${PV}"
361 doins -r "${T}"/source-tree/*
362
363 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
364}
365
366vdr-plugin_print_enable_command() {
367 local p_name c=0 l=""
368 for p_name in ${vdr_plugin_list}; do
369 c=$(( c+1 ))
370 l="$l ${p_name#vdr-}"
371 done
372
373 elog
374 case $c in
375 1) elog "Installed plugin${l}" ;;
376 *) elog "Installed $c plugins:${l}" ;;
377 esac
378 elog "To activate a plugin execute this command:"
379 elog "\teselect vdr-plugin enable <plugin_name> ..."
380 elog
381}
382
383has_vdr() {
384 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
385}
386
387## exported functions
162 388
163vdr-plugin_pkg_setup() { 389vdr-plugin_pkg_setup() {
164 # -fPIC is needed for shared objects on some platforms (amd64 and others) 390 # -fPIC is needed for shared objects on some platforms (amd64 and others)
165 append-flags -fPIC 391 append-flags -fPIC
166 392
393 # Plugins need to be compiled with position independent code, otherwise linking
394 # VDR against it will fail
395 if has_version ">=media-video/vdr-1.7.13"; then
396 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
397 fi
398
167 # Where should the plugins live in the filesystem 399 # Where should the plugins live in the filesystem
168 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins" 400 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
169 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums" 401 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
170 402
171 # was /usr/lib/... some time ago 403 # was /usr/lib/... some time ago
174 406
175 # Pathes to includes 407 # Pathes to includes
176 VDR_INCLUDE_DIR="/usr/include/vdr" 408 VDR_INCLUDE_DIR="/usr/include/vdr"
177 DVB_INCLUDE_DIR="/usr/include" 409 DVB_INCLUDE_DIR="/usr/include"
178 410
411 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
412 if has_version ">=media-video/vdr-1.6.0_p2-r7"; then
413 LOCDIR="/usr/share/locale"
414 else
415 LOCDIR="/usr/share/vdr/locale"
416 fi
179 417
418 if ! has_vdr; then
419 # set to invalid values to detect abuses
420 VDRVERSION="eclass_no_vdr_installed"
421 APIVERSION="eclass_no_vdr_installed"
422
423 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
424 einfo "VDR not found!"
425 else
426 # if vdr is required
427 die "VDR not found!"
428 fi
429 return
430 fi
431
180 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 432 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
181 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 433 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
182 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 434 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
183 435
184 einfo "Building ${PF} against vdr-${VDRVERSION}" 436 einfo "Compiling against"
185 einfo "APIVERSION: ${APIVERSION}" 437 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
438}
439
440vdr-plugin_src_util() {
441
442 while [ "$1" ]; do
443
444 case "$1" in
445 all)
446 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
447 ;;
448 prepare|all_but_unpack)
449 vdr-plugin_src_util add_local_patch patchmakefile i18n
450 ;;
451 unpack)
452 base_src_unpack
453 ;;
454 add_local_patch)
455 cd "${S}" || die "Could not change to plugin-source-directory!"
456 vdr_add_local_patch
457 ;;
458 patchmakefile)
459 cd "${S}" || die "Could not change to plugin-source-directory!"
460 vdr_patchmakefile
461 ;;
462 i18n)
463 cd "${S}" || die "Could not change to plugin-source-directory!"
464 vdr_i18n
465 ;;
466 esac
467
468 shift
469 done
186} 470}
187 471
188vdr-plugin_src_unpack() { 472vdr-plugin_src_unpack() {
189 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 473 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
190 eerror "Wrong use of vdr-plugin.eclass." 474 eerror "Wrong use of vdr-plugin.eclass."
191 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 475 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
192 echo 476 echo
193 eerror "Please report this at bugs.gentoo.org." 477 eerror "Please report this at bugs.gentoo.org."
194 die "vdr-plugin_pkg_setup not called!" 478 die "vdr-plugin_pkg_setup not called!"
195 fi 479 fi
196 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile 480 if [ -z "$1" ]; then
481 case "${EAPI:-0}" in
482 2|3)
483 vdr-plugin_src_util unpack
484 ;;
485 *)
486 vdr-plugin_src_util all
487 ;;
488 esac
489
490 else
491 vdr-plugin_src_util $@
492 fi
493}
494
495vdr-plugin_src_prepare() {
496 base_src_prepare
497 vdr-plugin_src_util prepare
498}
499
500vdr-plugin_src_compile() {
501 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
197 502
198 while [ "$1" ]; do 503 while [ "$1" ]; do
199 504
200 case "$1" in 505 case "$1" in
201 all_but_unpack) 506 copy_source)
202 vdr-plugin_src_unpack add_local_patch patchmakefile
203 ;;
204 unpack)
205 base_src_unpack
206 ;;
207 patchmakefile)
208 if ! cd ${S}; then
209 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
210 ewarn "Perhaps you find one among these:"
211 cd "${WORKDIR}"
212 ewarn "$(/bin/ls -1 ${WORKDIR})"
213 die "Could not change to plugin-source-directory!"
214 fi
215
216 einfo "Patching Makefile"
217 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
218 cp Makefile "${WORKDIR}"/Makefile.before
219
220 sed -i Makefile \
221 -e '1i\#Makefile was patched by vdr-plugin.eclass'
222
223 ebegin " Setting Pathes"
224 sed -i Makefile \
225 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
226 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
227 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
228 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
229 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
230 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
231 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
232 eend $?
233
234 ebegin " Converting to APIVERSION"
235 sed -i Makefile \
236 -e 's:^APIVERSION = :APIVERSION ?= :' \
237 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
238 -e '2i\APIVERSION = '"${APIVERSION}"
239 eend $?
240
241 ebegin " Correcting Compile-Flags"
242 sed -i Makefile \
243 -e 's:^CXXFLAGS:#CXXFLAGS:' \
244 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
245 eend $?
246
247 ebegin " Disabling file stripping"
248 sed -i Makefile \
249 -e '/@.*strip/d' \
250 -e '/strip \$(LIBDIR)\/\$@/d' \
251 -e '/^STRIP =/d' \
252 -e '/@.*\$(STRIP)/d'
253 eend $?
254
255 # Use a file instead of an variable as single-stepping via ebuild
256 # destroys environment.
257 touch ${WORKDIR}/.vdr-plugin_makefile_patched
258 ;;
259 add_local_patch)
260 cd ${S}
261 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
262 echo
263 einfo "Applying local patches"
264 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
265 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
266 done
267 fi
268 ;;
269 esac
270
271 shift
272 done
273}
274
275vdr-plugin_copy_source_tree() {
276 pushd . >/dev/null
277 cp -r ${S} ${T}/source-tree
278 cd ${T}/source-tree
279 cp "${WORKDIR}"/Makefile.before Makefile
280 sed -i Makefile \
281 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
282 -e 's:^CXXFLAGS:#CXXFLAGS:' \
283 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
284 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
285 popd >/dev/null
286}
287
288vdr-plugin_install_source_tree() {
289 einfo "Installing sources"
290 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
291 insinto ${destdir}-${PV}
292 doins -r ${T}/source-tree/*
293
294 dosym ${VDRPLUGIN}-${PV} ${destdir}
295}
296
297vdr-plugin_src_compile() {
298 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
299
300 while [ "$1" ]; do
301
302 case "$1" in
303 prepare)
304 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 507 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
305 ;; 508 ;;
306 compile) 509 compile)
307 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then 510 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
308 eerror "Wrong use of vdr-plugin.eclass." 511 eerror "Wrong use of vdr-plugin.eclass."
310 eerror "calling vdr-plugin_src_unpack to patch the Makefile." 513 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
311 echo 514 echo
312 eerror "Please report this at bugs.gentoo.org." 515 eerror "Please report this at bugs.gentoo.org."
313 die "vdr-plugin_src_unpack not called!" 516 die "vdr-plugin_src_unpack not called!"
314 fi 517 fi
315 cd ${S} 518 cd "${S}"
316 519
317 emake ${BUILD_PARAMS} ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed" 520 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
521
522 emake ${BUILD_PARAMS} \
523 ${BUILD_TARGETS} \
524 LOCALEDIR="${TMP_LOCALE_DIR}" \
525 LIBDIR="${S}" \
526 TMPDIR="${T}" \
527 || die "emake failed"
318 ;; 528 ;;
319 esac 529 esac
320 530
321 shift 531 shift
322 done 532 done
325vdr-plugin_src_install() { 535vdr-plugin_src_install() {
326 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree 536 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
327 cd "${WORKDIR}" 537 cd "${WORKDIR}"
328 538
329 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then 539 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
330 local mname=${P}-Makefile 540 local mname="${P}-Makefile"
331 cp Makefile ${mname}.patched 541 cp "${S}"/Makefile "${mname}.patched"
332 cp Makefile.before ${mname}.before 542 cp Makefile.before "${mname}.before"
333 543
334 diff -u ${mname}.before ${mname}.patched > ${mname}.diff 544 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
335 545
336 insinto "/usr/share/vdr/maintainer-data/makefile-changes" 546 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
337 doins ${mname}.diff 547 doins "${mname}.diff"
338 548
339 insinto "/usr/share/vdr/maintainer-data/makefile-before" 549 insinto "/usr/share/vdr/maintainer-data/makefile-before"
340 doins ${mname}.before 550 doins "${mname}.before"
341 551
342 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 552 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
343 doins ${mname}.patched 553 doins "${mname}.patched"
344 554
345 fi 555 fi
556
557
346 558
347 cd "${S}" 559 cd "${S}"
348 insinto "${VDR_PLUGIN_DIR}" 560 insinto "${VDR_PLUGIN_DIR}"
349 doins libvdr-*.so.* 561 doins libvdr-*.so.*
562
563 # create list of all created plugin libs
564 vdr_plugin_list=""
565 local p_name
566 for p in libvdr-*.so.*; do
567 p_name="${p%.so*}"
568 p_name="${p_name#lib}"
569 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
570 done
571
572 create_header_checksum_file ${vdr_plugin_list}
573 create_plugindb_file ${vdr_plugin_list}
574
575 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
576 einfo "Installing locales"
577 cd "${TMP_LOCALE_DIR}"
578 insinto "${LOCDIR}"
579 doins -r *
580 fi
581
582 cd "${S}"
350 local docfile 583 local docfile
351 for docfile in README* HISTORY CHANGELOG; do 584 for docfile in README* HISTORY CHANGELOG; do
352 [[ -f ${docfile} ]] && dodoc ${docfile} 585 [[ -f ${docfile} ]] && dodoc ${docfile}
353 done 586 done
354 587
365 598
366 if [[ -n ${VDR_RCADDON_FILE} ]]; then 599 if [[ -n ${VDR_RCADDON_FILE} ]]; then
367 insinto "${VDR_RC_DIR}" 600 insinto "${VDR_RC_DIR}"
368 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 601 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
369 fi 602 fi
370
371 create_header_checksum_file
372 create_plugindb_file
373} 603}
374 604
375vdr-plugin_pkg_postinst() { 605vdr-plugin_pkg_postinst() {
376 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then 606 vdr-plugin_print_enable_command
377 update_vdrplugindb 607
378 fi
379 elog
380 elog "The vdr plugin ${VDRPLUGIN} has now been installed."
381 elog "To activate execute the following command:"
382 elog
383 elog " emerge --config ${PN}"
384 elog
385 if [[ -n "${VDR_CONFD_FILE}" ]]; then 608 if [[ -n "${VDR_CONFD_FILE}" ]]; then
386 elog "And have a look at the config-file" 609 elog "Please have a look at the config-file"
387 elog "/etc/conf.d/vdr.${VDRPLUGIN}" 610 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
388 elog 611 elog
389 fi 612 fi
390} 613}
391 614
392vdr-plugin_pkg_postrm() { 615vdr-plugin_pkg_postrm() {
393 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
394 remove_vdrplugindb
395 fi
396 delete_orphan_plugindb_file 616 delete_orphan_plugindb_file
397} 617}
398 618
399vdr-plugin_pkg_config_final() {
400 diff ${conf_orig} ${conf}
401 rm ${conf_orig}
402}
403
404vdr-plugin_pkg_config_old() {
405 elog "Using interface of gentoo-vdr-scripts-0.3.6 and older"
406 if [[ -z "${INSTALLPLUGIN}" ]]; then
407 INSTALLPLUGIN="${VDRPLUGIN}"
408 fi
409 # First test if plugin is already inside PLUGINS
410 local conf=/etc/conf.d/vdr
411 conf_orig=${conf}.before_emerge_config
412 cp ${conf} ${conf_orig}
413
414 elog "Reading ${conf}"
415 if ! grep -q "^PLUGINS=" ${conf}; then
416 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
417 if [[ -n "${LINE}" ]]; then
418 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
419 else
420 echo 'PLUGINS=""' >> ${conf}
421 fi
422 unset LINE
423 fi
424
425 unset PLUGINS
426 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
427
428 active=0
429 for p in ${PLUGINS}; do
430 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
431 active=1
432 break;
433 fi
434 done
435
436 if [[ "${active}" == "1" ]]; then
437 elog "${INSTALLPLUGIN} already activated"
438 echo
439 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
440 if [[ "${answer}" != "yes" ]]; then
441 elog "aborted"
442 return
443 fi
444 elog "Removing ${INSTALLPLUGIN} from active plugins."
445 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
446 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
447 -e ${LINE}'s/ \( \)*/ /g' \
448 -e ${LINE}'s/ "/"/g' \
449 -e ${LINE}'s/" /"/g'
450
451 vdr-plugin_pkg_config_final
452 return
453 fi
454
455
456 elog "Adding ${INSTALLPLUGIN} to active plugins."
457 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
458 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
459 -e ${LINE}'s/ \( \)*/ /g' \
460 -e ${LINE}'s/ "/"/g' \
461 -e ${LINE}'s/" /"/g'
462
463 vdr-plugin_pkg_config_final
464}
465
466vdr-plugin_pkg_config_new() {
467 elog "Using interface introduced with gentoo-vdr-scripts-0.3.7"
468 if [[ -z "${INSTALLPLUGIN}" ]]; then
469 INSTALLPLUGIN="${VDRPLUGIN}"
470 fi
471
472 active=0
473 # First test if plugin is already inside PLUGINS
474 local conf=/etc/conf.d/vdr.plugins
475 exec 3<${conf}
476 while read -u 3 line; do
477 [[ ${line} == "" ]] && continue
478 [[ ${line:0:1} == "#" ]] && continue
479 set -- ${line}
480 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
481 done
482 exec 3<&-
483
484 if [[ $active == 0 ]]; then
485 elog "Adding ${INSTALLPLUGIN} to active plugins."
486
487 # The pure edit process.
488 echo "${INSTALLPLUGIN}" >> "${conf}"
489 else
490 elog "${INSTALLPLUGIN} already activated"
491 echo
492 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
493 if [[ "${answer}" != "yes" ]]; then
494 elog "aborted"
495 return
496 fi
497 elog "Removing ${INSTALLPLUGIN} from active plugins."
498
499 # The pure edit process
500 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
501 fi
502}
503
504vdr-plugin_pkg_config() { 619vdr-plugin_pkg_config() {
505 if has_version ">media-tv/gentoo-vdr-scripts-0.3.6"; then 620 ewarn "emerge --config ${PN} is no longer supported"
506 vdr-plugin_pkg_config_new 621 vdr-plugin_print_enable_command
507 else
508 vdr-plugin_pkg_config_old
509 fi
510} 622}
511 623
512fix_vdr_libsi_include() 624case "${EAPI:-0}" in
513{ 625 2|3)
514 einfo "Fixing include of libsi-headers" 626 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
515 local f 627 ;;
516 for f; do 628 *)
517 sed -i "${f}" \
518 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
519 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
520 done
521}
522
523EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 629 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
630 ;;
631esac

Legend:
Removed from v.1.46  
changed lines
  Added in v.1.77

  ViewVC Help
Powered by ViewVC 1.1.20